<?php

/* --------------------------------- */
/*  Squelettes mobiles iTwX Mobile	 */
/*  (c) 2011 cf@cannaweb.ch			 */
/*  Licence GPL 3					 */
/* --------------------------------- */


if (!defined('_ECRIRE_INC_VERSION')) return;

// define('URLS_ITWX_EXEMPLE', 'spip.php?page=iphone_article&id_article=12');
define('URLS_ITWX_EXEMPLE', 'Squel pour Smartphone (spip.php?page=smart_...)');

####### modifications possibles dans ecrire/mes_options
# on peut indiquer '.html' pour faire joli
define ('_terminaison_urls_itwx', '');
# ci-dessous, ce qu'on veut ou presque (de preference pas de '/')
# attention toutefois seuls '' et '=' figurent dans les modes de compatibilite
define ('_separateur_urls_itwx', '');
# on peut indiquer '' si on a installe le .htaccess
define ('_debut_urls_itwx', get_spip_script('./').'?');
# on peut aussi forcer avec spip.php?
define ('_debut_urls_itwx', 'spip.php?');

# normalement le define est fait dans itwx_options.php
// if (!defined('_type_urls_itwx')) define ('_type_urls_itwx', 'tab');
// if (!defined('_type_urls_itwx')) define ('_type_urls_itwx', 'mob');
if (!defined('_type_urls_itwx')) define ('_type_urls_itwx', 'smart');
#######


function _generer_url_itwx($type,$id, $args='', $ancre='') {
	if ($generer_url_externe = charger_fonction("generer_url_$type",'urls',true)) {
		$url = $generer_url_externe($id, $args, $ancre);
		if (NULL != $url) return $url;
	}

	if ($type == 'document') {
		include_spip('inc/documents');
		return generer_url_document_dist($id, $args, $ancre);
	} 
	/*
	 * Modificatiion principal 
	 * si le $type est contenu dans le tableau $itwx_url_type
	 * on fabrique les urls qui corresponde au squel itwx
	 * sinon on genere des urls par default de spip
	 * a faire: generer les urls selon l'ancien type_urls !
	 */

	global $itwx_url_type ;
	if (!empty($itwx_url_type[$type])) {
		/* 
		 * Generation de l'url itwx sous la forme :
		 * spip.php?page=smart_article&id_article=12
		 * spip.php?page=mob_rubrique&id_rubrique=12
		 */
		$url = _debut_urls_itwx . 'page='._type_urls_itwx.'_'.$type.'&id_'.$itwx_url_type[$type].'='. $id ;
	} else {
		// generer ancien_type_urls... a faire
		$url = _debut_urls_itwx . $type . _separateur_urls_itwx . $id . _terminaison_urls_itwx;
	}

	if ($args) $args = strpos($url,'?') ? "&$args" : "?$args";
	return _DIR_RACINE . $url . $args . ($ancre ? "#$ancre" : '');
}

// retrouve le fond et les parametres d'une URL abregee
// le contexte deja existant est fourni dans args sous forme de tableau ou query string
function urls_itwx_dist($i, &$entite, $args='', $ancre='')
{
	if (is_numeric($i))
		return _generer_url_itwx($entite, $i, $args, $ancre);

	// traiter les injections du type domaine.org/spip.php/cestnimportequoi/ou/encore/plus/rubrique23
	if ($GLOBALS['profondeur_url']>0 AND $entite=='sommaire'){
		return array(array(),'404');
	}

	// voir s'il faut recuperer le id_* implicite et les &debut_xx;
	if (is_array($args))
		$contexte = $args;
	else
		parse_str($args,$contexte);
	include_spip('inc/urls');
	$r = nettoyer_url_page($i, $contexte);
	if ($r) {
		array_pop($r); // nettoyer_url_page renvoie un argument de plus inutile ici
		return $r;
	}

	/*
	 * Le bloc qui suit sert a faciliter les transitions depuis
	 * le mode 'urls-propres' vers les modes 'urls-standard' et 'url-html'
	 * Il est inutile de le recopier si vous personnalisez vos URLs
	 * et votre .htaccess
	 */
	// Si on est revenu en mode html, mais c'est une ancienne url_propre
	// on ne redirige pas, on assume le nouveau contexte (si possible)
	$url = $i;
	$url_propre = isset($url)
		? $url
		: (isset($_SERVER['REDIRECT_url_propre'])
			? $_SERVER['REDIRECT_url_propre']
			: (isset($_ENV['url_propre'])
				? $_ENV['url_propre']
				: ''
				));
	if ($url_propre) {
		if ($GLOBALS['profondeur_url']<=0)
			$urls_anciennes = charger_fonction('propres','urls',true);
		else
			$urls_anciennes = charger_fonction('arbo','urls',true);
		return $urls_anciennes?$urls_anciennes($url_propre, $entite, $contexte):'';
	}
	/* Fin du bloc compatibilite url-propres */
}

// fin redirection url interne

?>