<?php

/* --------------------------------- */
/*  Squelettes mobiles iTwX Mobile	 */
/*  (c) 2011 iTwX Design			 */
/*  Licence GPL 3					 */
/*  ©2011 Seds & Christian			 */
/* --------------------------------- */
 

/* Fonctions de redirection site classique vers squelettes iTwX */

global  $itwx_reg_tab, $itwx_reg_smart, $itwx_reg_mob, $itwx_reg_moball ;
// si $redirtab == 'on', reg_tab pour toutes tablettes
$itwx_reg_tab = '/(iPad|androidtablette|nokiatablette|blackberrytablette|archos|Nexus 7 Build)/i' ;
// si $diritwx == 'dirsmart', reg_smart pour smartphones
$itwx_reg_smart = '/(iPhone|Android|BlackBerry|HP iPAQ|Windows Phone|Symbian|Smartphone|Palm|HTC)/i' ;
// si $diritwx == 'dirtout', reg_smart pour smartphones + reg_mob pour autres phones
$itwx_reg_mob = '/(webOS|Opera Mobi|Opera Mini|IEMobile|LG|MOT|Nokia|Sagem|Samsung|SGH|Siemens|SIE|SonyEricsson|Windows CE|WindowsCE|MSIEMobile|MIDP|Fennec|Maemo|Tear|Midoriarmv6l|armv7l|MMP|UCWEB)/i' ;
// si $diritwx == 'dirmob', reg_moball pour tous phones
$itwx_reg_moball = '/(iPhone|Android|BlackBerry|HP iPAQ|Windows Phone|Symbian|Smartphone|PalmwebOS|Opera Mobi|Opera Mini|IEMobile|LG|MOT|Nokia|Sagem|Samsung|SGH|Siemens|SIE|SonyEricsson|Windows CE|WindowsCE|MSIEMobile|MIDP|Fennec|Maemo|Tear|Midoriarmv6l|armv7l|MMP|UCWEB)/i' ;



// determiner url itwx
function itwx_urls ($type,$id_object,$type_object) {
	return $GLOBALS['meta']['adresse_site'].'/spip.php?page='.$type.'_'.$type_object . (($id_object > 0) ? '&id_'.$type_object.'='.$id_object : '');
}


// emplacement du code à inserer
function itwx_inserer_codejs ($page,$code) {
	$pos_head = strpos($page, '</head>');
	if ($pos_head === false) return $page ;
	return substr($page,0,$pos_head) . $code . substr ($page,$pos_head) ;
}


// si cookie absent ecrire cookie session
function itwx_verifCookieRedirection(){
	include_spip('inc/cookie');
    if (isset($_COOKIE["itwx_redirection"])) return "non";
    else {
    	spip_setcookie('itwx_redirection', "oui", 0);
        return "oui";
	}
}


// si cookie absent ou expire executer script question, si cookie present pas de script
function itwx_inserer_codejs_question ($page,$url,$reg,$type) {
	$cookie = itwx_verifCookieRedirection();
	$script = '
<script type="text/javascript">//<![CDATA[
	if ( (navigator.userAgent.match('.$reg.')) )
		if (confirm("'.attribut_html (_T ('itwx:'.$type.'_question')).'")) window.location = "'.$url.'";
//]]></script>
';
	if($cookie == "oui") return itwx_inserer_codejs($page,$script) ;
	else return $page;
}


// script de redirection automatique
function itwx_inserer_codejs_auto ($page,$url,$reg,$type) {
	return itwx_inserer_codejs($page,'
<script type="text/javascript">//<![CDATA[
	if ( (navigator.userAgent.match('.$reg.')) ) window.location = "'.$url.'";
//]]></script>
') ; 
}


// redirection par notification selon cfg
function itwx_inserer_codejs_question_globale ($page,$id_object,$type_object) {
	global $itwx_reg_tab, $itwx_reg_smart, $itwx_reg_mob, $itwx_reg_moball ;

	$nosmart = lire_config('itwx/nosmart');
	$notab = lire_config('itwx/notab');

	// langue<h1></h1>
	if ($type_object == 'article' || $type_object == 'rubrique' || $type_object == 'breve') {
		$lang_obj = trim(recuperer_fond('itwx/redir/lang-'.$type_object, array('id_'.$type_object => $id_object))) ;
		if (!empty($lang_obj)) changer_langue ($lang_obj) ;
	}

	if (!$notab == 'on') {	// si active, tab vers tab_
		$page = itwx_inserer_codejs_question($page,itwx_urls ('tab',$id_object,$type_object),$itwx_reg_tab,'tab') ; 
	// option
	} elseif (!$nosmart == 'on') {	// vers les pages, choix : les 2
		$page = itwx_inserer_codejs_question($page,itwx_urls ('smart',$id_object,$type_object),$itwx_reg_smart,'smart') ;	// smart vers smart_
		$page = itwx_inserer_codejs_question($page,itwx_urls ('mob',$id_object,$type_object),$itwx_reg_mob,'mob') ;	// mob vers mob_
	// ou
	} if ($nosmart == 'on') {	// smart + mob vers mob_
		$page = itwx_inserer_codejs_question($page,itwx_urls ('mob',$id_object,$type_object),$itwx_reg_moball,'mob') ;
	

	}
	return $page ;
}


// redirection automatique selon cfg
function itwx_inserer_codejs_auto_globale ($page,$id_object,$type_object) {
	global $itwx_reg_tab, $itwx_reg_smart, $itwx_reg_mob, $itwx_reg_mobalta ;

	$nosmart = lire_config('itwx/nosmart');
	$notab = lire_config('itwx/notab');

	$diritwx = lire_config('itwx/diritwx');
	$redirtab = lire_config('itwx/redirtab');

	if ($type_object == 'article' || $type_object == 'rubrique' || $type_object == 'breve') {
		$lang_obj = trim(recuperer_fond('itwx/redir/lang-'.$type_object, array('id_'.$type_object => $id_object))) ;
		if (!empty($lang_obj)) changer_langue ($lang_obj) ;
	}
	
	if ($redirtab == 'on') {	// si active, tab vers tab_
		$page = itwx_inserer_codejs_auto($page,itwx_urls ('tab',$id_object,$type_object),$itwx_reg_tab) ;
	// option
	} elseif (!$nosmart == 'on') {	// vers les pages, choix : les 2
		$page = itwx_inserer_codejs_auto($page,itwx_urls ('smart',$id_object,$type_object),$itwx_reg_smart) ;	// smart vers smart_
		$page = itwx_inserer_codejs_auto($page,itwx_urls ('mob',$id_object,$type_object),$itwx_reg_mob) ;	// mob vers mob_
	// ou
	} elseif ($diritwx == 'dirsmart') {	// smart vers smart_
		$page = itwx_inserer_codejs_auto($page,itwx_urls ('smart',$id_object,$type_object),$itwx_reg_smart) ;
	// ou
	} if ($diritwx == 'dirmob') {	// smart + mob vers mob_
		$page = itwx_inserer_codejs_auto($page,itwx_urls ('mob',$id_object,$type_object),$itwx_reg_moball) ;

	}
	return $page ;
}


// execution des scripts de redirection selon config pages
function itwx_affichage_final ($page) {
spip_log ('contexte : '.var_export($GLOBALS['contexte'],true)) ;
//spip_log ('meta : '.var_export($GLOBALS['meta'],true)) ;

	if (substr($GLOBALS['contexte']['page'],0,4) != 'tab_' && substr($GLOBALS['contexte']['page'],0,6) != 'smart_' && substr($GLOBALS['contexte']['page'],0,4) != 'mob_' ) {
		//if (isset($GLOBALS['contexte']['id_article']) && ($GLOBALS['contexte']['page'] == 'article') ) {
		if (isset($GLOBALS['contexte']['id_article'])) {
			$art = lire_config('itwx/art');
			if ($art == 'artaucun') return $page ;
			$id_object = $GLOBALS['contexte']['id_article'];
			$type_object = 'article';
			if ($art == 'artnotif') $page = itwx_inserer_codejs_question_globale ($page,$id_object,$type_object) ;
			else $page = itwx_inserer_codejs_auto_globale ($page,$id_object,$type_object) ;

		//} elseif (isset($GLOBALS['contexte']['id_rubrique']) && ($GLOBALS['contexte']['page'] == 'rubrique') ) {
		} elseif (isset($GLOBALS['contexte']['id_rubrique'])) {
			$rub = lire_config('itwx/rub');
			if ($rub == 'rubaucun') return $page ;
			$id_object   = $GLOBALS['contexte']['id_rubrique'];
			$type_object = 'rubrique';
			if ($rub == 'rubnotif') $page = itwx_inserer_codejs_question_globale ($page,$id_object,$type_object) ;
			else $page = itwx_inserer_codejs_auto_globale ($page,$id_object,$type_object) ;

		//} elseif (isset($GLOBALS['contexte']['id_breve']) && ($GLOBALS['contexte']['page'] == 'breve') ) {
		} elseif (isset($GLOBALS['contexte']['id_breve'])) {
			$bre = lire_config('itwx/bre');
			if ($bre == 'breaucun') return $page ;

			$id_object   = $GLOBALS['contexte']['id_breve'];
			$type_object = 'breve';
			if ($bre == 'brenotif') $page = itwx_inserer_codejs_question_globale ($page,$id_object,$type_object) ;
			else $page = itwx_inserer_codejs_auto_globale ($page,$id_object,$type_object) ;

		} elseif (!isset($GLOBALS['contexte']['page'])) {
			// ??? sommaire ??? uniquement ??? je l'espère :)
			$som = lire_config('itwx/som');
			if ($som == 'somaucun') return $page ;

			$type_object = 'sommaire';
			if ($som == 'somnotif') $page = itwx_inserer_codejs_question_globale ($page,-1,$type_object) ;
			else $page = itwx_inserer_codejs_auto_globale ($page,-1,$type_object) ;
		}
	}

	return $page ;
}
